<?php

/**
 * This class was created using wsdl2php.
 *
 * @wsdl2php  Mon, 17 Mar 2014 19:06:02 +0200 - Last modified
 * @WSDL      https://test.connectwise.com/v4_6_release/apis/1.5/ServiceTicketApi.asmx?wsdl
 * @Processed Wed, 23 Apr 2014 03:12:27 +0300
 * @Hash      0a3f191e2e8483b12d8b8a32bd180934
 */

/**
 * ServiceTicketApi class
 *
 * ConnectWise Service Ticket API
 *
 * @author wsdl2php
 */
class ServiceTicketApi extends SoapClient
{

    /**
     * Endpoint for service calls.
     */
    // const SERVICE_ENDPOINT = 'https://test.connectwise.com/v4_6_release/apis/1.5/ServiceTicketApi.asmx';

    /**
     * Namespace for service calls.
     */
    const SERVICE_NAMESPACE = 'http://connectwise.com';

    /**
     * Default class mapping for this service.
     *
     * @var array
     */
    private static $a_ClassMap = array(
        'AddOrUpdateServiceTicketViaCompanyId'         => 'ServiceTicketApi_AddOrUpdateServiceTicketViaCompanyId',
        'AddOrUpdateServiceTicketViaCompanyIdResponse' => 'ServiceTicketApi_AddOrUpdateServiceTicketViaCompanyIdResponse',
        'AddOrUpdateServiceTicketViaManagedId'         => 'ServiceTicketApi_AddOrUpdateServiceTicketViaManagedId',
        'AddOrUpdateServiceTicketViaManagedIdResponse' => 'ServiceTicketApi_AddOrUpdateServiceTicketViaManagedIdResponse',
        'AddOrUpdateTicketProduct'                     => 'ServiceTicketApi_AddOrUpdateTicketProduct',
        'AddOrUpdateTicketProductResponse'             => 'ServiceTicketApi_AddOrUpdateTicketProductResponse',
        'AddServiceTicketViaCompanyId'                 => 'ServiceTicketApi_AddServiceTicketViaCompanyId',
        'AddServiceTicketViaCompanyIdResponse'         => 'ServiceTicketApi_AddServiceTicketViaCompanyIdResponse',
        'AddServiceTicketViaManagedId'                 => 'ServiceTicketApi_AddServiceTicketViaManagedId',
        'AddServiceTicketViaManagedIdResponse'         => 'ServiceTicketApi_AddServiceTicketViaManagedIdResponse',
        'AddTicketProduct'                             => 'ServiceTicketApi_AddTicketProduct',
        'AddTicketProductResponse'                     => 'ServiceTicketApi_AddTicketProductResponse',
        'ApiCredentials'                               => 'ServiceTicketApi_ApiCredentials',
        'ArrayOfComponent'                             => 'ServiceTicketApi_ArrayOfComponent',
        'ArrayOfDocumentInfo'                          => 'ServiceTicketApi_ArrayOfDocumentInfo',
        'ArrayOfKnowledgeBaseResult'                   => 'ServiceTicketApi_ArrayOfKnowledgeBaseResult',
        'ArrayOfString'                                => 'ServiceTicketApi_ArrayOfString',
        'ArrayOfTicket'                                => 'ServiceTicketApi_ArrayOfTicket',
        'ArrayOfTicketConfiguration'                   => 'ServiceTicketApi_ArrayOfTicketConfiguration',
        'ArrayOfTicketNote'                            => 'ServiceTicketApi_ArrayOfTicketNote',
        'ArrayOfTicketProduct'                         => 'ServiceTicketApi_ArrayOfTicketProduct',
        'Component'                                    => 'ServiceTicketApi_Component',
        'DeleteServiceTicket'                          => 'ServiceTicketApi_DeleteServiceTicket',
        'DeleteServiceTicketResponse'                  => 'ServiceTicketApi_DeleteServiceTicketResponse',
        'DeleteTicketDocument'                         => 'ServiceTicketApi_DeleteTicketDocument',
        'DeleteTicketDocumentResponse'                 => 'ServiceTicketApi_DeleteTicketDocumentResponse',
        'DeleteTicketProduct'                          => 'ServiceTicketApi_DeleteTicketProduct',
        'DeleteTicketProductResponse'                  => 'ServiceTicketApi_DeleteTicketProductResponse',
        'DocumentInfo'                                 => 'ServiceTicketApi_DocumentInfo',
        'FindServiceTickets'                           => 'ServiceTicketApi_FindServiceTickets',
        'FindServiceTicketsResponse'                   => 'ServiceTicketApi_FindServiceTicketsResponse',
        'GetDocument'                                  => 'ServiceTicketApi_GetDocument',
        'GetDocumentResponse'                          => 'ServiceTicketApi_GetDocumentResponse',
        'GetServiceStatuses'                           => 'ServiceTicketApi_GetServiceStatuses',
        'GetServiceStatusesResponse'                   => 'ServiceTicketApi_GetServiceStatusesResponse',
        'GetServiceTicket'                             => 'ServiceTicketApi_GetServiceTicket',
        'GetServiceTicketResponse'                     => 'ServiceTicketApi_GetServiceTicketResponse',
        'GetTicketCount'                               => 'ServiceTicketApi_GetTicketCount',
        'GetTicketCountResponse'                       => 'ServiceTicketApi_GetTicketCountResponse',
        'GetTicketDocuments'                           => 'ServiceTicketApi_GetTicketDocuments',
        'GetTicketDocumentsResponse'                   => 'ServiceTicketApi_GetTicketDocumentsResponse',
        'GetTicketProductList'                         => 'ServiceTicketApi_GetTicketProductList',
        'GetTicketProductListResponse'                 => 'ServiceTicketApi_GetTicketProductListResponse',
        'KbSearchType'                                 => 'ServiceTicketApi_KbSearchType',
        'KnowledgeBaseResult'                          => 'ServiceTicketApi_KnowledgeBaseResult',
        'LoadServiceTicket'                            => 'ServiceTicketApi_LoadServiceTicket',
        'LoadServiceTicketResponse'                    => 'ServiceTicketApi_LoadServiceTicketResponse',
        'NsnStatusId'                                  => 'ServiceTicketApi_NsnStatusId',
        'SearchKnowledgebase'                          => 'ServiceTicketApi_SearchKnowledgebase',
        'SearchKnowledgebaseCount'                     => 'ServiceTicketApi_SearchKnowledgebaseCount',
        'SearchKnowledgebaseCountResponse'             => 'ServiceTicketApi_SearchKnowledgebaseCountResponse',
        'SearchKnowledgebaseResponse'                  => 'ServiceTicketApi_SearchKnowledgebaseResponse',
        'ServiceTicket'                                => 'ServiceTicketApi_ServiceTicket',
        'SrBillingMethod'                              => 'ServiceTicketApi_SrBillingMethod',
        'Ticket'                                       => 'ServiceTicketApi_Ticket',
        'TicketConfiguration'                          => 'ServiceTicketApi_TicketConfiguration',
        'TicketNote'                                   => 'ServiceTicketApi_TicketNote',
        'TicketProduct'                                => 'ServiceTicketApi_TicketProduct',
        'UpdateServiceTicketViaCompanyId'              => 'ServiceTicketApi_UpdateServiceTicketViaCompanyId',
        'UpdateServiceTicketViaCompanyIdResponse'      => 'ServiceTicketApi_UpdateServiceTicketViaCompanyIdResponse',
        'UpdateServiceTicketViaManagedId'              => 'ServiceTicketApi_UpdateServiceTicketViaManagedId',
        'UpdateServiceTicketViaManagedIdResponse'      => 'ServiceTicketApi_UpdateServiceTicketViaManagedIdResponse',
        'UpdateTicketNote'                             => 'ServiceTicketApi_UpdateTicketNote',
        'UpdateTicketNoteResponse'                     => 'ServiceTicketApi_UpdateTicketNoteResponse',
        'UpdateTicketProduct'                          => 'ServiceTicketApi_UpdateTicketProduct',
        'UpdateTicketProductResponse'                  => 'ServiceTicketApi_UpdateTicketProductResponse',
    );

    /**
     * Service Constructor
     *
     * @param string $s_WSDL    The location of the WSDL file.
     * @param array  $a_Options Any additional parameters to add to the service.
     */
    public function __construct($s_WSDL = Null, array $a_Options = array())
    {
        /**
         * Use the optional WSDL file location if it is supplied.
         */
        // $s_WSDL = is_null($s_WSDL) ? 'https://test.connectwise.com/v4_6_release/apis/1.5/ServiceTicketApi.asmx?wsdl' : $s_WSDL;

        /**
         * Add the classmap to the options.
         */
        foreach (self::$a_ClassMap as $s_ServiceClassName => $s_MappedClassName) {
            if (!isset($a_Options['classmap'][$s_ServiceClassName])) {
                $a_Options['classmap'][$s_ServiceClassName] = $s_MappedClassName;
            }
        }

        parent::__construct($s_WSDL, $a_Options);
    }

    /**
     * Service call proxy.
     *
     * @param string       $s_ServiceName    The name of the service being called.
     * @param array        $a_Parameters     The parameters being supplied to the service.
     * @param SOAPHeader[] $a_RequestHeaders An array of SOAPHeaders.
     * @return mixed The service response.
     */
    protected function callProxy($s_ServiceName, array $a_Parameters = Null, array $a_RequestHeaders = Null)
    {
        $m_Result = $this->__soapCall($s_ServiceName, $a_Parameters, array(
            'uri'        => 'http://tempuri.org/',
            'soapaction' => '',
            ), (!empty($a_RequestHeaders) ? array_filter($a_RequestHeaders) : Null), $a_ResponseHeaders);

        if (!empty($a_ResponseHeaders)){
            foreach($a_ResponseHeaders as $s_HeaderName => $m_Data){
                $s_PropertyName = "o_{$s_HeaderName}";
                $this->$s_PropertyName = $m_Data;
            }
        }

        return $m_Result;
    }

    /**
     * Build and populate a SOAP header.
     *
     * @param string       $s_HeaderName The name of the services SOAP Header.
     * @param array|object $m_Data       Any data that can be mapped to the SOAP Header. Public properties of objects will be used if an object is supplied.
     * @param string       $s_Namespace  The namespace which will default to this service's namespace.
     * @return SoapHeader
     */
    public function assignSoapHeader($s_HeaderName, $m_Data = Null, $s_Namespace = self::SERVICE_NAMESPACE)
    {

        /**
         * Is there a corresponding property of this service for the requested SOAP Header?
         * Is there a mapped class for this SOAP Header?
         * Do we have any data to populate the SOAP Header with?
         */
        $s_LocalPropertyName = "o_{$s_HeaderName}";
        if (property_exists($this, $s_LocalPropertyName) && isset(self::$a_ClassMap[$s_HeaderName]) && !empty($m_Data)) {

            /**
             * Start with no data for the SOAP Header.
             */
            $a_HeaderData = Null;

            /**
             * Get the mapped class and get the properties defined for the SOAP Header.
             */
            $o_HeaderClass      = new ReflectionClass(self::$a_ClassMap[$s_HeaderName]);
            $a_HeaderProperties = $o_HeaderClass->getProperties();

            /**
             * Produce an array of public data from an object.
             */
            if (is_object($m_Data)) {
                $o_DataClass      = new ReflectionClass($m_Data);
                $a_DataProperties = $o_DataClass->getProperties(ReflectionProperty::IS_PUBLIC);
                $a_Data           = array();
                foreach ($a_DataProperties as $o_Property) {
                    $s_PropertyName          = $o_Property->name;
                    $a_Data[$s_PropertyName] = $m_Data->$s_PropertyName;
                }
            }
            else if (is_array($m_Data)) {
                $a_Data = $m_Data;
            }

            /**
             * Process the data as an array.
             */
            if (is_array($a_Data)) {
                foreach ($a_HeaderProperties as $o_Property) {
                    $s_PropertyName = $o_Property->name;
                    if (isset($a_Data[$s_PropertyName])) {
                        $a_HeaderData[$s_PropertyName] = $a_Data[$s_PropertyName];
                    }
                }
            }

            /**
             * Build the SOAP Header and assign it the corresponding property.
             */
            $this->$s_LocalPropertyName = new SoapHeader($s_Namespace, $s_HeaderName, $a_HeaderData);
        }
    }

    /**
     * Gets a service ticket by the ticket number. If no service ticket exists with the given ticket
     * number, null is returned.
     *
     * @param ServiceTicketApi_GetServiceTicket $parameters
     * @return ServiceTicketApi_GetServiceTicketResponse
     */
    public function GetServiceTicket(ServiceTicketApi_GetServiceTicket $parameters)
    {
        return $this->callProxy('GetServiceTicket', array($parameters));
    }

    /**
     * Gets a service ticket by the ticket number. If no service ticket exists with the given ticket
     * number, an error is returned.
     *
     * @param ServiceTicketApi_LoadServiceTicket $parameters
     * @return ServiceTicketApi_LoadServiceTicketResponse
     */
    public function LoadServiceTicket(ServiceTicketApi_LoadServiceTicket $parameters)
    {
        return $this->callProxy('LoadServiceTicket', array($parameters));
    }

    /**
     * Adds a new service ticket for a company identified by managed id.
     *
     * @param ServiceTicketApi_AddServiceTicketViaManagedId $parameters
     * @return ServiceTicketApi_AddServiceTicketViaManagedIdResponse
     */
    public function AddServiceTicketViaManagedId(ServiceTicketApi_AddServiceTicketViaManagedId $parameters)
    {
        return $this->callProxy('AddServiceTicketViaManagedId', array($parameters));
    }

    /**
     * Updates an existing service ticket for a company identified by managed id.
     *
     * @param ServiceTicketApi_UpdateServiceTicketViaManagedId $parameters
     * @return ServiceTicketApi_UpdateServiceTicketViaManagedIdResponse
     */
    public function UpdateServiceTicketViaManagedId(ServiceTicketApi_UpdateServiceTicketViaManagedId $parameters)
    {
        return $this->callProxy('UpdateServiceTicketViaManagedId', array($parameters));
    }

    /**
     * Adds or updates a service ticket for a company identified by managed id. If the service
     * ticket number is 0, the service ticket is added. If non-zero, the existing service ticket
     * with that ticket number is updated.
     *
     * @param ServiceTicketApi_AddOrUpdateServiceTicketViaManagedId $parameters
     * @return ServiceTicketApi_AddOrUpdateServiceTicketViaManagedIdResponse
     */
    public function AddOrUpdateServiceTicketViaManagedId(ServiceTicketApi_AddOrUpdateServiceTicketViaManagedId $parameters)
    {
        return $this->callProxy('AddOrUpdateServiceTicketViaManagedId', array($parameters));
    }

    /**
     * Adds a new service ticket for a company identified by the text-based company id.
     *
     * @param ServiceTicketApi_AddServiceTicketViaCompanyId $parameters
     * @return ServiceTicketApi_AddServiceTicketViaCompanyIdResponse
     */
    public function AddServiceTicketViaCompanyId(ServiceTicketApi_AddServiceTicketViaCompanyId $parameters)
    {
        return $this->callProxy('AddServiceTicketViaCompanyId', array($parameters));
    }

    /**
     * Updates an existing service ticket for a company identified by the text-based company id.
     *
     * @param ServiceTicketApi_UpdateServiceTicketViaCompanyId $parameters
     * @return ServiceTicketApi_UpdateServiceTicketViaCompanyIdResponse
     */
    public function UpdateServiceTicketViaCompanyId(ServiceTicketApi_UpdateServiceTicketViaCompanyId $parameters)
    {
        return $this->callProxy('UpdateServiceTicketViaCompanyId', array($parameters));
    }

    /**
     * Adds or updates a service ticket for a company identified by the text-based company id. If
     * the service ticket number is 0, the service ticket is added. If non-zero, the existing
     * service ticket with that ticket number is updated.
     *
     * @param ServiceTicketApi_AddOrUpdateServiceTicketViaCompanyId $parameters
     * @return ServiceTicketApi_AddOrUpdateServiceTicketViaCompanyIdResponse
     */
    public function AddOrUpdateServiceTicketViaCompanyId(ServiceTicketApi_AddOrUpdateServiceTicketViaCompanyId $parameters)
    {
        return $this->callProxy('AddOrUpdateServiceTicketViaCompanyId', array($parameters));
    }

    /**
     * Deletes a service ticket by the ticket number.
     *
     * @param ServiceTicketApi_DeleteServiceTicket $parameters
     * @return ServiceTicketApi_DeleteServiceTicketResponse
     */
    public function DeleteServiceTicket(ServiceTicketApi_DeleteServiceTicket $parameters)
    {
        return $this->callProxy('DeleteServiceTicket', array($parameters));
    }

    /**
     * Finds service ticket information by a set of conditions.  If isOpen is set, it will
     * pre-filter by the ticket status.
     *
     * @param ServiceTicketApi_FindServiceTickets $parameters
     * @return ServiceTicketApi_FindServiceTicketsResponse
     */
    public function FindServiceTickets(ServiceTicketApi_FindServiceTickets $parameters)
    {
        return $this->callProxy('FindServiceTickets', array($parameters));
    }

    /**
     * Gets the count of service tickets that meet the specified conditions
     *
     * @param ServiceTicketApi_GetTicketCount $parameters
     * @return ServiceTicketApi_GetTicketCountResponse
     */
    public function GetTicketCount(ServiceTicketApi_GetTicketCount $parameters)
    {
        return $this->callProxy('GetTicketCount', array($parameters));
    }

    /**
     * Gets the list of statuses available to the specified ticket.
     *
     * @param ServiceTicketApi_GetServiceStatuses $parameters
     * @return ServiceTicketApi_GetServiceStatusesResponse
     */
    public function GetServiceStatuses(ServiceTicketApi_GetServiceStatuses $parameters)
    {
        return $this->callProxy('GetServiceStatuses', array($parameters));
    }

    /**
     * Performs a Knowledgebase search using the specified parameters
     *
     * @param ServiceTicketApi_SearchKnowledgebase $parameters
     * @return ServiceTicketApi_SearchKnowledgebaseResponse
     */
    public function SearchKnowledgebase(ServiceTicketApi_SearchKnowledgebase $parameters)
    {
        return $this->callProxy('SearchKnowledgebase', array($parameters));
    }

    /**
     * Counts the Knowledgebase records that will be returned by performing the associated search.
     *
     * @param ServiceTicketApi_SearchKnowledgebaseCount $parameters
     * @return ServiceTicketApi_SearchKnowledgebaseCountResponse
     */
    public function SearchKnowledgebaseCount(ServiceTicketApi_SearchKnowledgebaseCount $parameters)
    {
        return $this->callProxy('SearchKnowledgebaseCount', array($parameters));
    }

    /**
     * Removes the document from the ticket
     *
     * @param ServiceTicketApi_DeleteTicketDocument $parameters
     * @return ServiceTicketApi_DeleteTicketDocumentResponse
     */
    public function DeleteTicketDocument(ServiceTicketApi_DeleteTicketDocument $parameters)
    {
        return $this->callProxy('DeleteTicketDocument', array($parameters));
    }

    /**
     * Get a list of products for the specified ticket
     *
     * @param ServiceTicketApi_GetTicketProductList $parameters
     * @return ServiceTicketApi_GetTicketProductListResponse
     */
    public function GetTicketProductList(ServiceTicketApi_GetTicketProductList $parameters)
    {
        return $this->callProxy('GetTicketProductList', array($parameters));
    }

    /**
     * Add a product on a ticket
     *
     * @param ServiceTicketApi_AddTicketProduct $parameters
     * @return ServiceTicketApi_AddTicketProductResponse
     */
    public function AddTicketProduct(ServiceTicketApi_AddTicketProduct $parameters)
    {
        return $this->callProxy('AddTicketProduct', array($parameters));
    }

    /**
     * Update a product on a ticket
     *
     * @param ServiceTicketApi_UpdateTicketProduct $parameters
     * @return ServiceTicketApi_UpdateTicketProductResponse
     */
    public function UpdateTicketProduct(ServiceTicketApi_UpdateTicketProduct $parameters)
    {
        return $this->callProxy('UpdateTicketProduct', array($parameters));
    }

    /**
     * Add or Update a product on a ticket
     *
     * @param ServiceTicketApi_AddOrUpdateTicketProduct $parameters
     * @return ServiceTicketApi_AddOrUpdateTicketProductResponse
     */
    public function AddOrUpdateTicketProduct(ServiceTicketApi_AddOrUpdateTicketProduct $parameters)
    {
        return $this->callProxy('AddOrUpdateTicketProduct', array($parameters));
    }

    /**
     * Delete Product from a ticket
     *
     * @param ServiceTicketApi_DeleteTicketProduct $parameters
     * @return ServiceTicketApi_DeleteTicketProductResponse
     */
    public function DeleteTicketProduct(ServiceTicketApi_DeleteTicketProduct $parameters)
    {
        return $this->callProxy('DeleteTicketProduct', array($parameters));
    }

    /**
     * Gets the documents attached to the specified ticket
     *
     * @param ServiceTicketApi_GetTicketDocuments $parameters
     * @return ServiceTicketApi_GetTicketDocumentsResponse
     */
    public function GetTicketDocuments(ServiceTicketApi_GetTicketDocuments $parameters)
    {
        return $this->callProxy('GetTicketDocuments', array($parameters));
    }

    /**
     * Gets the document for the specified documentId
     *
     * @param ServiceTicketApi_GetDocument $parameters
     * @return ServiceTicketApi_GetDocumentResponse
     */
    public function GetDocument(ServiceTicketApi_GetDocument $parameters)
    {
        return $this->callProxy('GetDocument', array($parameters));
    }

    /**
     * Add a new ticket note or update an existing ticket note by service ticket Recid.
     *
     * @param ServiceTicketApi_UpdateTicketNote $parameters
     * @return ServiceTicketApi_UpdateTicketNoteResponse
     */
    public function UpdateTicketNote(ServiceTicketApi_UpdateTicketNote $parameters)
    {
        return $this->callProxy('UpdateTicketNote', array($parameters));
    }

}
