#Security none
#
#no firewall or packet inspection
#
PATH=$PATH:/sbin

#allow all, input, output and forward
iptables -F
#flush mangle
iptables -t mangle --flush
#accept all chains in and out
iptables -P INPUT ACCEPT
iptables -P OUTPUT ACCEPT
iptables -P FORWARD ACCEPT
iptables -A INPUT -j ACCEPT
iptables -A OUTPUT -j ACCEPT
iptables -A FORWARD -j ACCEPT
# save and clear
iptables-save > /etc/sysconfig/iptables
#clear
iptables -nL
eval `grep BPDIR /etc/default/bp.ini`
echo "DPU Security|Level: None|" > $BPDIR/lcdman.dir/lcd_sec_none.txt
echo "DPU Security|Level: None|" > $BPDIR/lcdman.dir/lcd_sec_stat.txt
# 2627 - have the security scripts set the data port in master.ini to match security level
#        hi, med, low should all set to 1745.
#        none should set to 1744 or leave as is.
$BPDIR/bin/bputil -p "Configuration Options" "data" "1744" $BPDIR/bpinit/master.ini 2> /dev/null

exit 13
