#!/usr/bin/php
<?php

bp_bypass_cookie(3);

class Crontab {
    
    // In this class, array instead of string would be the standard input / output format.
    
    // Legacy way to add a job:
    // $output = shell_exec('(crontab -l; echo "'.$job.'") | crontab -');
    
    static private function stringToArray($jobs = '') {
        $array = explode(PHP_EOL, trim($jobs)); // trim() gets rid of the last \r\n
        foreach ($array as $key => $item) {
            if ($item == '') {
                unset($array[$key]);
            }
        }
        return $array;
    }
    
    static private function arrayToString($jobs = array()) {
        $string = implode(PHP_EOL, $jobs);
        return $string;
    }
    
    static public function getJobs() {
        $output = shell_exec('crontab -l');
        return self::stringToArray($output);
    }
    
    static public function saveJobs($jobs = array()) {
        $output = shell_exec('echo "'.self::arrayToString($jobs).'" | crontab -');
        return $output;	
    }
    
    static public function doesJobExist($job = '') {
	$jobs = self::getJobs();
	if (in_array($job, $jobs)) {
            return true;
        } else {
            return false;
        }
    }
    
    static public function removeJob($job = '') {
        if (self::doesJobExist($job)) {
            $jobs = self::getJobs();
            unset($jobs[array_search($job, $jobs)]);
            return self::saveJobs($jobs);
        } else {
            return false;
        }
    }
    
}

$gfslitejob = "0 12 * * * php /var/www/html/recoveryconsole/bpl/gfslite.php >/dev/null 2>&1";

print "About to delete cron job ".$gfslitejob."\n";
$retval = Crontab::removeJob($gfslitejob);
if ($retval == NULL) {	
	bp_rm_gfs_ini_section();
	$retval = true;
}
var_dump($retval);	

