<?php

//IN PROGRESS
class PSA
{
    private $BP;

    public function __construct($BP)
    {
        $this->BP = $BP;

    }


    public function get($which)
    {
        $dpuID = 1;
        $checkSeverity = false;
        $severity = -1;

        if (is_string($which[0])) {
            switch ($which[0]) {
                case 'tools':
                    $psaInfo = $this->BP->get_psa_tools($dpuID);
                    break;
                case 'config':
                    $psaInfo = $this->BP->get_psa_config($dpuID);
                    break;
                case 'tickets':
                    $psaInfo = $this->BP->get_psa_history($dpuID);
                    if(isset($which[1]) and is_string($which[1])) {
                        $checkSeverity = true;
                        switch ($which[1]) {
                            case 'critical':
                                $severity = 1;
                                break;
                            case 'warning':
                                $severity = 2;
                                break;
                            case 'notice':
                                $severity = 3;
                                break;
                        }
                    }
                    break;
                default:
                    return false;
            }
        } else if (is_numeric($which) and $which < 0) {
            $psaInfo = $this->BP->get_psa_history($dpuID);
        } else {
            // I don't believe we'll ever reach this else, but added just in case.
            return false;
        }
        $allPsa = array();
        foreach ($psaInfo as $info) {
            if ($checkSeverity and $severity != $info['severity']){
                continue;
            }
            if ($which){
                $allPsa[] = $info;
            }
        }
        return($allPsa);
    }
}

?>
