<?php

$dir = '/api/includes/reports';

class ReplicationActivityReport
{
    private $BP;

    public function __construct( $BP, $functionsClass )
    {
        $this->BP = $BP;
        $this->functions = $functionsClass;
    }

    public function get_replication_activity_report($sid = false, $data)
    {
        if ( $sid === false )
        {
            $sid = $this->BP->get_local_system_id();
        }

        $systemName = $this->functions->getSystemNameFromID( $sid );
        $hostInfo = $this->BP->get_host_info( $systemName, $sid );

        $report = array();
        $report_link = 'https://'.$hostInfo['ip'].'/recoveryconsole/reports.dir/replication_report.html';
        $report_contents = file_get_contents($report_link);
        if( $report_contents !== false )
        {
            $report['html'] = $report_contents;
        }
        else
        {
            $report = false;
            // Add a failure message here
        }
        return $report;
    }

}