<?php
// defines BP, xml, action, cookie
require 'header.php';

$rootPassword = urldecode($_REQUEST['password']);
$bRestart = isset($_REQUEST['restart']) ? true : false;

global $Log;
$Log->enterFunction("shutdown_system", "root password", $bRestart);
$result = shutdown_system($rootPassword, $bRestart, $errorMessage);
$Log->exitFunction("shutdown_system", $result);
if ($result === 0) {
	$BP->buildResult($xml, true);
} else {
	$BP->buildResult($xml, false, $errorMessage);
}
echo($xml->getXml());


// function to shutdown and optionally restart system.  There must
// be an entry for apache for /sbin/shutdown (with PASSWORD) in
// /etc/sudoers.
//
function shutdown_system($rootPassword, $bRestart, &$msg) {
	$status = -1;
	$res = trim(shell_exec('echo $UID'));
	// we're not running as root
	if (!login_is_valid('root', $rootPassword)) {
		$msg = "Invalid password for root user.";
		return 1;
	}
	$haltOrRestart = $bRestart ? "-r" : "-h";
	$stringRest = $bRestart ? " and restarted." : ".";
	$command = sprintf("sudo -S /sbin/shutdown %s now", $haltOrRestart);
	$handle = popen($command, 'w');
	fwrite($handle, "$rootPassword\n");
	$status = pclose($handle);
	if ($status != 0) {
		$msg = "The system could not be shutdown" . $stringRest;
	} else {
		$msg = "The system will be shutdown.". $stringRest;
	}
	return $status;
}

/* checks for valid login credentials, returns 1 if valid, 0 otherwise
 *
 * @param $username - user to check
 * @param $password - password for this user
 * @return - 1 for valid login, 0 otherwise
 */
function login_is_valid($username, $password) {
	$passencoded = "'" . str_replace("'", "'\''", $password) . "'";
	$userencoded = "'" . str_replace("'", "'\''", $username) . "'";
	$cmd = "echo -e $passencoded | sudo -u $userencoded -S whoami 2>/dev/null";
	$res = trim(shell_exec($cmd));
	if ($res == $username) {
		return 1;
	} else {
		return 0;
	}
}
?>